using System;
public class SaveAndLoadXML_UseReaderWriter
{
  //XML-,       
  const string XML_ROOT_TAG = "AllMyData";
  const string XML_USERINFO_TAG = "UserInfo";
  const string XML_USERID_TAG = "UserID";
  const string XML_NAMEINFO_TAG = "Name";
  const string XML_FIRSTNAME_TAG = "FirstName";
  const string XML_LASTNAME_TAG = "LastName";

  // ,     
  private enum ReadLocation
  {
    inAllMyData,
    inUserInfo,
    inUserID,
    inName,
    inFirstName,
    inLastName,
  }

  //-----------------------------------------------------------------------
  //  
  //
  // [in] fileName:   ,    
  // [in] userId:     ,    
  // [in] firstName:  ,    
  // [in] lastName:   ,    
  //-----------------------------------------------------------------------
  public static void XML_SaveUserInfo(string fileName, 
    int userId, string firstName, string lastName)
  {
    System.Xml.XmlTextWriter xmlTextWriter;
    xmlTextWriter = new System.Xml.XmlTextWriter(fileName, 
      System.Text.Encoding.Default);

    //  !
    //<Root>
    xmlTextWriter.WriteStartElement(XML_ROOT_TAG);

    //<Root>
    xmlTextWriter.WriteStartElement(XML_USERINFO_TAG);
    //<Root><UserID>

    //<Root><UserInfo>
    xmlTextWriter.WriteStartElement(XML_NAMEINFO_TAG);
    //<Root><UserInfo><Name>
    xmlTextWriter.WriteStartElement(XML_FIRSTNAME_TAG);
    //<Root><UserInfo><Name><FirstName>
    xmlTextWriter.WriteString(firstName); // 
    xmlTextWriter.WriteEndElement(); //  
    //<Root><UserInfo><Name>
    xmlTextWriter.WriteStartElement(XML_LASTNAME_TAG);
    //<Root><UserInfo><Name><LastName>
    xmlTextWriter.WriteString(lastName); // 
    xmlTextWriter.WriteEndElement(); //  
    //<Root><UserInfo><Name>
    xmlTextWriter.WriteEndElement(); //  
    //<Root><UserInfo>

    //<Root><UserInfo>
    xmlTextWriter.WriteStartElement(XML_USERID_TAG);
    //<Root><UserInfo><UserID>

    // 
    xmlTextWriter.WriteString(userId.ToString()); 
    xmlTextWriter.WriteEndElement(); //  UserID
    //<Root><UserInfo>

    xmlTextWriter.WriteEndElement(); //  UserInfo
    //<Root>

    xmlTextWriter.WriteEndElement(); //  
    //

    xmlTextWriter.Close();
  }

  //----------------------------------------------------------------
  //  
  //
  // [in] fileName:    ,    
  // [out] userId:      
  // [out] firstName:   
  // [out] lastName:    
  //----------------------------------------------------------------
  public static void XML_LoadUserInfo(string fileName, 
    out int userId, out string firstName, out string lastName)
  {
    ReadLocation currentReadLocation;

    //   
    userId = 0;
    firstName = "";
    lastName = "";


    System.Xml.XmlTextReader xmlReader = 
      new System.Xml.XmlTextReader(fileName);

    xmlReader.WhitespaceHandling = 
      System.Xml.WhitespaceHandling.None;

    bool readSuccess;

    readSuccess = xmlReader.Read();
    if(readSuccess == false)
    {
      throw new System.Exception(" XML-  !");
    }

    //  ,     
    if(xmlReader.Name != XML_ROOT_TAG)
    {
      throw new System.Exception(
        "    !");
    }

    //    
    currentReadLocation = ReadLocation.inAllMyData;

    //------------------------------------------------------
    //      
    //------------------------------------------------------
    while(readSuccess)
    {
		
      switch(xmlReader.NodeType)
      {
          //     
        case System.Xml.XmlNodeType.Element:
        {
          string nodeName = xmlReader.Name;

          LoadHelper_NewElementEncountered(nodeName, 
            ref currentReadLocation);
          break;
        }

          //----------------------------------------------------
          //       
          // ,   
          //----------------------------------------------------
        case System.Xml.XmlNodeType.Text:
        {

          switch(currentReadLocation)
          {
            case ReadLocation.inFirstName:
            { firstName = xmlReader.Value; break; }

            case ReadLocation.inLastName:
            { lastName = xmlReader.Value; break; }

            case ReadLocation.inUserID:
            {
              userId = System.Convert.ToInt32(xmlReader.Value);
              break;
            }

          }
          break;
        }

          //-------------------------------------------------------------
          //,   
          //
          //
          //         
          // ,    ,   
          //    
          //-------------------------------------------------------------
        case System.Xml.XmlNodeType.EndElement:
        {
          bool continueParsing;
          continueParsing = LoadHelper_EndElementEncountered(
            ref currentReadLocation);

          if(continueParsing == false) 
          { goto finished_reading_wanted_data; }
          break;
        }

        default:
        {
          // ,   XML-  , 
          //     XML-   
          //   ...
          System.Windows.Forms.MessageBox.Show(
            "  XML- " + xmlReader.Name);
          break;
        }

      } //  Case,     
      // XML-, 

      //   
      readSuccess = xmlReader.Read();
    }

    //      ,   
    //XML- UserInfo,   XML-,  
    // , -  
    throw new Exception("   UserInfo  XML-!");

    finished_reading_wanted_data:
      // ,     !
      xmlReader.Close();
  }


  //--------------------------------------------------------
  // ,     
  // ,     ,
  //   
  //--------------------------------------------------------
  private static bool LoadHelper_EndElementEncountered(
    ref ReadLocation currentReadLocation)
  {
    switch(currentReadLocation)
    {
        //    Name,   
        //   UserInfo
      case ReadLocation.inName:
      { currentReadLocation = ReadLocation.inUserInfo; break; }

        //    FirstName,   
        //   Name
      case ReadLocation.inFirstName:
      { currentReadLocation = ReadLocation.inName; break; }

        //    LastName,   
        //   Name
      case ReadLocation.inLastName:
      { currentReadLocation = ReadLocation.inName; break; }

        //    UserID,   
        //   UserInfo
      case ReadLocation.inUserID:
      { currentReadLocation = ReadLocation.inUserInfo; break; }

        //    UserInfo,    
        //     UserID, FirstName 
        // LastName.
        //
        //   ,      
        //,    !
      case ReadLocation.inUserInfo:
      {
        return false;  //   
      }
    }

    return true; // 
  }

  private static void LoadHelper_NewElementEncountered(
    string nodeName, ref ReadLocation currentReadLocation)
  {
    //---------------------------------------------------------
    //    !
    //
    //    ,   , 
    //      
    //---------------------------------------------------------
    switch (currentReadLocation)
    {
        //     AllMyData,    
        // ,   
      case (ReadLocation.inAllMyData):
      {
        if (nodeName == XML_USERINFO_TAG)
        {
          currentReadLocation = ReadLocation.inUserInfo;
        }
        break;
      }
        //     UserInfo,   
        // ,   
      case (ReadLocation.inUserInfo):
      {
        if (nodeName == XML_USERID_TAG)
        {
          currentReadLocation = ReadLocation.inUserID;
        }
        else if (nodeName == XML_NAMEINFO_TAG)
        {
          currentReadLocation = ReadLocation.inName;
        }
        break;
      }

        //     Name,    
        // ,   
      case (ReadLocation.inName):
      {
        if (nodeName == XML_FIRSTNAME_TAG)
        {
          currentReadLocation = ReadLocation.inFirstName;
        }
        else if (nodeName == XML_LASTNAME_TAG)
        {
          currentReadLocation = ReadLocation.inLastName;
        }
        break;
      }
    }
  } // 
} // 
