'-----------------------------------------------------------------------------
' #1:      PerformanceSampling, 
'               .   , 
'                 .
' #2:       Form,  
'            TreeView   Button,    
'              xxx_Click.
'-----------------------------------------------------------------------------
' ,      
' TreeView
Const NUMBER_ITEMS As Integer = 800

'-------------------------------------------------------------------------
'   "Fill: Baseline"
'
'       
' TreeView
'-------------------------------------------------------------------------
Private Sub UnOptimizedFill_Click(ByVal sender As _
  System.Object, ByVal e As System.EventArgs) _
  Handles UnOptimizedFill.Click

  '      
   If (TreeView1.Nodes.Count > 0) Then
        TreeView1.BeginUpdate()
     TreeView1.Nodes.Clear()
     TreeView1.EndUpdate()
     TreeView1.Update()
    End If
   '     
   '  .       !
   System.GC.Collect()

   ' 
   PerformanceSampling.StartSample(0, "TreeViewPopulate")

   '    TreeView
   Dim i As Integer
   For i = 1 To NUMBER_ITEMS
     TreeView1.Nodes.Add("TreeItem" + CStr(i))
   Next

   '    
   PerformanceSampling.StopSample(0)
   MsgBox(PerformanceSampling.GetSampleDurationText(0))
End Sub

'-------------------------------------------------------------------------
'   "Clear: Baseline"
'
'       
' TreeView
'-------------------------------------------------------------------------
Private Sub UnOptimizedClear_Click(ByVal sender As _
      System.Object, ByVal e As System.EventArgs) _
      Handles UnOptimizedClear.Click

   '     
   '  
   System.GC.Collect()

   ' 
   PerformanceSampling.StartSample(1, "TreeViewClear")
   TreeView1.Nodes.Clear()

   PerformanceSampling.StopSample(1)
   MsgBox(PerformanceSampling.GetSampleDurationText(1))
End Sub

'--------------------------------------------------
'   "Fill: BeginUpdate"
'
',     BeginUpdate()
'--------------------------------------------------
Private Sub UseBeginEndUpdateForFill_Click(ByVal sender As _
  System.Object, ByVal e As System.EventArgs) _
  Handles UseBeginEndUpdateForFill.Click

   '      
   If (TreeView1.Nodes.Count > 0) Then
        TreeView1.BeginUpdate()
     TreeView1.Nodes.Clear()
     TreeView1.EndUpdate()
     TreeView1.Update()
    End If

   '     
   '  .       !
   System.GC.Collect()

   ' 
   PerformanceSampling.StartSample(2, _
                "Populate - Use BeginUpdate")

   '    TreeView
   TreeView1.BeginUpdate()
   Dim i As Integer
   For i = 1 To NUMBER_ITEMS
         TreeView1.Nodes.Add("TreeItem" + i.ToString())
   Next
   TreeView1.EndUpdate()

   '    
   PerformanceSampling.StopSample(2)
   MsgBox(PerformanceSampling.GetSampleDurationText(2))
  End Sub

'--------------------------------------------------------
'   "Clear: BeginUpdate"
',     BeginUpdate()
'--------------------------------------------------------
Private Sub UseBeginEndUpdateForClear_Click(ByVal sender As _
    System.Object, ByVal e As System.EventArgs) _
    Handles UseBeginEndUpdateForClear.Click

   '     
   '  .       !
   System.GC.Collect()

   ' 
   PerformanceSampling.StartSample(3, "Clear - Use BeginUpdate")

   TreeView1.BeginUpdate()
   TreeView1.Nodes.Clear()
   TreeView1.EndUpdate()

   '    
   PerformanceSampling.StopSample(3)
   MsgBox(PerformanceSampling.GetSampleDurationText(3))
End Sub

'--------------------------------------------
'   "Fill: Use Array"
'
',    
'--------------------------------------------
Private Sub FillArrayBeforeAttachingToTree_Click(ByVal _
    sender As System.Object, ByVal e As System.EventArgs) _
    Handles FillArrayBeforeAttachingToTree.Click

  '      
  If (TreeView1.Nodes.Count > 0) Then
      TreeView1.BeginUpdate()
    TreeView1.Nodes.Clear()
    TreeView1.EndUpdate()
    TreeView1.Update()
  End If

  '     
  '  .       !
  System.GC.Collect()

  ' 
  PerformanceSampling.StartSample(4, "Populate - Use Array")


  '      
  Dim newTreeNodes() As System.Windows.Forms.TreeNode
  ReDim newTreeNodes(NUMBER_ITEMS - 1)

  ' 
  Dim i As Integer
  For i = 0 To NUMBER_ITEMS - 1
        newTreeNodes(i) = _
      New System.Windows.Forms.TreeNode("TreeItem" + _
          i.ToString())
  Next

  '     TreeView
  TreeView1.BeginUpdate()
  TreeView1.Nodes.AddRange(newTreeNodes)
  TreeView1.EndUpdate()

  '    
  PerformanceSampling.StopSample(4)
  MsgBox(PerformanceSampling.GetSampleDurationText(4))
End Sub
