using System;
using System.Drawing;

internal class GraphicsGlobals
{
  //==========================================================================
  // 1:    
  //               .
  //
  //         , 
  //     
  //==========================================================================
  private static Pen s_bluePen;
  public static Pen globalBluePen
  {
  get
  {
      //     
      if(s_bluePen == null)
      {
        s_bluePen  = new System.Drawing.Pen(
                            System.Drawing.Color.Blue);
      }
      return s_bluePen;  
  }
  } // 

  //=========================================================
  // 2: 
  //    
  //  Pen, ImageAttribute, Font  Brush.
  //
  //       , 
  //      .
  //=========================================================
  public static Pen g_blackPen;
  public static Pen g_whitePen;
  public static System.Drawing.Imaging.ImageAttributes 
                g_ImageAttribute;
  private static bool s_alreadyInitialized;
  public static Font g_boldFont;
  public static Font g_smallTextFont;
  public static Brush g_greenBrush;
  public static Brush g_yellowBrush;
  public static Brush g_redBrush;
  public static Brush g_blackBrush;

  //==============================================================
  //          
  //  
  //==============================================================
  public static void InitializeGlobals()
  {
    if (s_alreadyInitialized == true) {return;}
    g_blackPen = new System.Drawing.Pen(Color.Black);
    g_whitePen = new System.Drawing.Pen(Color.White);
    g_ImageAttribute = new 
            System.Drawing.Imaging.ImageAttributes();
    g_ImageAttribute.SetColorKey(Color.White, Color.White);
    g_boldFont = new Font(FontFamily.GenericSerif, 
                          10, FontStyle.Bold);
    g_smallTextFont = new Font(FontFamily.GenericSansSerif,
                           8, FontStyle.Regular);

    g_blackBrush = new SolidBrush(System.Drawing.Color.Black);
    g_greenBrush = new SolidBrush(
                            System.Drawing.Color.LightGreen);
    g_yellowBrush = new SolidBrush(System.Drawing.Color.Yellow);
    g_redBrush = new SolidBrush(System.Drawing.Color.Red);


    s_alreadyInitialized = true;
  }

  //================================================================
  // 3:    .
  //            ,   
  //             ()  .
  //
  //================================================================
  private static  Bitmap  m_CaveMan_Bitmap1;
  private static  Bitmap  m_CaveMan_Bitmap2;
  private static  Bitmap  m_CaveMan_Bitmap3;
  private static  Bitmap  m_CaveMan_Bitmap4;
  private static  System.Collections.ArrayList 
                    m_colCaveManBitmaps;

  //----------------------------------------------------------
  //      
  //----------------------------------------------------------
  public static System.Collections.ArrayList 
                            g_CaveManPictureCollection()
  {
    //     ,      
    if (m_CaveMan_Bitmap1 == null) 
    {
      //-----------------------------------------------------------------
      // .     
      //     .
      //
      //       
      //,     (    
      //     ).
      //-----------------------------------------------------------------
      //     
      System.Reflection.Assembly thisAssembly = 
              System.Reflection.Assembly.GetExecutingAssembly();

      //  
      System.Reflection.AssemblyName thisAssemblyName = 
                                     thisAssembly.GetName();
      string assemblyName = thisAssemblyName.Name;

      //        
      m_CaveMan_Bitmap1 = new System.Drawing.Bitmap(
          thisAssembly.GetManifestResourceStream(
          assemblyName + ".Hank_RightRun1.bmp"));

      m_CaveMan_Bitmap2 = new System.Drawing.Bitmap(
           thisAssembly.GetManifestResourceStream(
           assemblyName + ".Hank_RightRun2.bmp"));

      m_CaveMan_Bitmap3 = new System.Drawing.Bitmap(
            thisAssembly.GetManifestResourceStream(
            assemblyName + ".Hank_LeftRun1.bmp"));
            
      m_CaveMan_Bitmap4 = new System.Drawing.Bitmap(
            thisAssembly.GetManifestResourceStream(
            assemblyName + ".Hank_LeftRun2.bmp"));

      //   
      m_colCaveManBitmaps = new System.Collections.ArrayList();
      m_colCaveManBitmaps.Add(m_CaveMan_Bitmap1);
      m_colCaveManBitmaps.Add(m_CaveMan_Bitmap2);
      m_colCaveManBitmaps.Add(m_CaveMan_Bitmap3);
      m_colCaveManBitmaps.Add(m_CaveMan_Bitmap4);
    }

    // 
    return m_colCaveManBitmaps;
  }
} // 
