using System;
//----------------------------------------------------------------------------
//    ,   TextBox.
//     TextBox,   
//  ,   ,
//      :
//###-##-####. 
//       ,
//   .
//----------------------------------------------------------------------------
public class SocialSecurityTextBox : 
                            System.Windows.Forms.TextBox
{
private bool m_inputIsFullValidEntry;

//-------------------------------------------------------------
//,    
//  
//-------------------------------------------------------------
public bool IsFullValidInput
{get {return m_inputIsFullValidEntry;}}

// StringBuilder,     
System.Text.StringBuilder m_sb;
//   
const int SSNumberLength = 11;

//-------------------------------------------------------------
//
//-------------------------------------------------------------
public SocialSecurityTextBox()
{
  //     StringBuilder  
  //       
      m_sb = new System.Text.StringBuilder(SSNumberLength + 5);
      m_inputIsFullValidEntry = false;
}

//---------------------------------------------------------------------
//       
// :
//
//      :  ###-##-####
// :  01234567890
//
// [in] inString          : ,    
// [in/out] selectionStart:     ; 
//                                
//                             
//---------------------------------------------------------------------
private string formatText_NNN_NN_NNNN(string inString, 
                                      ref int selectionStart)
{
  const int firstDashIndex = 3;
  const int secondDashIndex = 6;
  
  //      
  //  StringBuilder,      .
  m_sb.Length = 0;
  m_sb.Append(inString);
  
  //------------------------------------------------------------
  //    ,   
  //     
  //------------------------------------------------------------
  int currentCharIndex;
  currentCharIndex = 0;
  while((currentCharIndex < m_sb.Length) && 
        (currentCharIndex < SSNumberLength))
  {
      char currentChar;
      currentChar = m_sb[currentCharIndex];
    if((currentCharIndex == firstDashIndex) ||
        (currentCharIndex == secondDashIndex))
      //-------------------------------------------------------
      //    "-"
      //-------------------------------------------------------
      {
        if(currentChar != '-')
        {
          // 
          m_sb.Insert(currentCharIndex, "-");
          
          //      ,
          //    
          if(currentCharIndex <= selectionStart)
          {
            selectionStart++;
          }         
        }
        //  ,    
        currentCharIndex++;
      }
      else
      //-------------------------------------------------------
      //   
      //-------------------------------------------------------
      {
        if(System.Char.IsDigit(currentChar) == false)
        {
          // 
          m_sb.Remove(currentCharIndex,1);
          //      ,
          //    
          if(currentCharIndex < selectionStart)
          {
            selectionStart--;
          }

          //    ,   
          // ,    ,
          //  
        }
        else
        {
          //  ,  .
          currentCharIndex++;
        }
      }
  }

  //   ,  
  if(m_sb.Length > SSNumberLength)
  {
    m_sb.Length = SSNumberLength;
  }

  //  
  return m_sb.ToString();
}

bool m_in_OnChangeFunction;
protected override void OnTextChanged(EventArgs e)
{
 //------------------------------------------------------------------
 //    .Text,    
 //  .        
 //         
 //- .
 //------------------------------------------------------------------
  if(m_in_OnChangeFunction == true)
  {
      return;
  }

  //,       OnChanged,
  //      (.  )
  m_in_OnChangeFunction = true;

  //   .Text
  string oldText = this.Text;
  //   SelectionStart
  int selectionStart = this.SelectionStart;
  // ,     
  string newText = formatText_NNN_NN_NNNN(oldText, 
                                ref selectionStart);

  //    ,  
  // .Text
  if (System.String.Compare(oldText, newText ) != 0)
  {
      //    
      this.Text = newText;
      //   
      this.SelectionStart = selectionStart;
  }

  //     
  // , ,       
  //  ,      
  // ###-##-####.
  if (this.Text.Length == SSNumberLength)
  {
    //,       
    m_inputIsFullValidEntry = true;
  }
  else
  {
    //,         
    m_inputIsFullValidEntry = false;
  }

  //       ,    
  //,   
  base.OnTextChanged(e);

  //,          
  //    .
  m_in_OnChangeFunction = false;
}

protected override void OnKeyPress(
                    System.Windows.Forms.KeyPressEventArgs e)
{
  //  ,        , 
  //   ,   .
  char keyPressed = e.KeyChar;
  if(System.Char.IsLetter(keyPressed))
  {
    //   ,   
    e.Handled = true;
    return;
  }
//    
base.OnKeyPress (e);
} // 
} // 
