//----------------------------------------------------------------
//       PictureBox
//----------------------------------------------------------------
const int bitmap_dx = 200;
const int bitmap_dy = 100;

//-------------------------------------------------------
//     
//-------------------------------------------------------
System.Drawing.Bitmap m_backgroundBitmap;
void CreateBackground()
{
  if(m_backgroundBitmap == null) 
  {
    m_backgroundBitmap = new Bitmap(bitmap_dx, bitmap_dy);
  }
  //   
  System.Drawing.Graphics gfx;
  gfx = System.Drawing.Graphics.FromImage(m_backgroundBitmap);
  gfx.Clear(System.Drawing.Color.White);

  //  
  System.Drawing.Brush myBrush;
  myBrush = new System.Drawing.SolidBrush(
                            System.Drawing.Color.Black);

  for(int y = 0; y < bitmap_dy; y = y + 15)
  {
    gfx.DrawString("I am the BACKGROUND IMAGE...hello", 
                  this.Font, myBrush, 0, y);
  }

  //
  myBrush.Dispose();
  gfx.Dispose();
}

//-------------------------------------------------------
//     
//-------------------------------------------------------
System.Drawing.Bitmap m_foregroundBitmap;
void CreateForeground()
{
  if(m_foregroundBitmap == null) 
  {
    m_foregroundBitmap = new Bitmap(bitmap_dx, bitmap_dy);
  }
  //    
  System.Drawing.Graphics gfx;
  gfx = System.Drawing.Graphics.FromImage(m_foregroundBitmap);
  gfx.Clear(System.Drawing.Color.Blue);

  //    
  System.Drawing.Brush yellowBrush;
  yellowBrush = new System.Drawing.SolidBrush(
                           System.Drawing.Color.Yellow);
  gfx.FillEllipse(yellowBrush, 130, 4, 40, 70);
  gfx.FillRectangle(yellowBrush, 5, 20, 110, 30);
  gfx.FillEllipse(yellowBrush, 60, 75, 130, 20);

  //
  yellowBrush.Dispose();
  gfx.Dispose();
}

//-----------------------------------------------------------------
//    PictureBox   
//-----------------------------------------------------------------
private void SetPictureBoxDimensions()
{
  pictureBox1.Width = bitmap_dx;
  pictureBox1.Height = bitmap_dy;
  pictureBox1.Left = 20;
}

//---------------------------------------------------------------------
// :      PictureBox
//---------------------------------------------------------------------
private void buttonDrawBackground_Click(object sender, 
                                        System.EventArgs e)
{
    SetPictureBoxDimensions();
    CreateBackground();
    pictureBox1.Image = m_backgroundBitmap;
}

//-----------------------------------------------------------------------
// :      PictureBox
//-----------------------------------------------------------------------

private void buttonDrawForeground_Click(object sender,
                                        System.EventArgs e)
{
  SetPictureBoxDimensions();
  CreateForeground();
  pictureBox1.Image = m_foregroundBitmap;

}

//---------------------------------------------------------------------------
// :      
//                .   ,  
//                        
//                    
//                
//---------------------------------------------------------------------------
private void buttonDrawBackgroundPlusForeground_Click(
                            object sender, System.EventArgs e)
{
  SetPictureBoxDimensions();
  CreateForeground();
  CreateBackground();
  //  Graphics   , 
  //     .
  System.Drawing.Graphics gfx;
  gfx = System.Drawing.Graphics.FromImage(m_backgroundBitmap);

  //--------------------------------------------------------
  //  ImageAttributes.    
  //      
  //--------------------------------------------------------
  System.Drawing.Imaging.ImageAttributes trasparencyInfo = 
                new System.Drawing.Imaging.ImageAttributes();
  //--------------------------------------------------------
  //  
  //--------------------------------------------------------
  trasparencyInfo.SetColorKey(System.Drawing.Color.Yellow,
                              System.Drawing.Color.Yellow);
  
  //  
  System.Drawing.Rectangle rect = 
                new System.Drawing.Rectangle(0,0,
                    m_backgroundBitmap.Width,
                    m_backgroundBitmap.Height);

  //-----------------------------------------------------------------------
  //       
  //     ImageAttributes    
  //,     
  //-----------------------------------------------------------------------
  gfx.DrawImage(m_foregroundBitmap,
                rect, 
                0,0, 
                m_foregroundBitmap.Width,
                m_foregroundBitmap.Height,
                System.Drawing.GraphicsUnit.Pixel,
                trasparencyInfo);
  //
  gfx.Dispose();

  //     
  pictureBox1.Image = m_backgroundBitmap;
}
