'----------------------------------------------------------------
'       PictureBox
'----------------------------------------------------------------
Const bitmap_dx As Integer = 200
Const bitmap_dy As Integer = 100
'-------------------------------------------------------
'     
'-------------------------------------------------------
Private m_backgroundBitmap As System.Drawing.Bitmap
Sub CreateBackground()
  If (m_backgroundBitmap Is Nothing) Then
      m_backgroundBitmap = New Bitmap(bitmap_dx, bitmap_dy)
  End If

  '   
  Dim gfx As System.Drawing.Graphics
  gfx = System.Drawing.Graphics.FromImage(m_backgroundBitmap)
  gfx.Clear(System.Drawing.Color.White)

  '  
  Dim myBrush As System.Drawing.Brush
  myBrush = New System.Drawing.SolidBrush( _
                            System.Drawing.Color.Black)

  Dim y As Integer
  For y = 0 To bitmap_dy Step 15
      gfx.DrawString("I am the BACKGROUND IMAGE...hello", _
                  Me.Font, myBrush, 0, y)
  Next

  '
  myBrush.Dispose()
  gfx.Dispose()
End Sub

'-------------------------------------------------------
'     
'-------------------------------------------------------
Private m_foregroundBitmap As System.Drawing.Bitmap
Sub CreateForeground()
  If (m_foregroundBitmap Is Nothing) Then
      m_foregroundBitmap = New Bitmap(bitmap_dx, bitmap_dy)
  End If
  '    
  Dim gfx As System.Drawing.Graphics
  gfx = System.Drawing.Graphics.FromImage(m_foregroundBitmap)
  gfx.Clear(System.Drawing.Color.Blue)

  '    
  Dim yellowBrush As System.Drawing.Brush
  yellowBrush = New System.Drawing.SolidBrush( _
                           System.Drawing.Color.Yellow)
  gfx.FillEllipse(yellowBrush, 130, 4, 40, 70)
  gfx.FillRectangle(yellowBrush, 5, 20, 110, 30)
  gfx.FillEllipse(yellowBrush, 60, 75, 130, 20)

  '
  yellowBrush.Dispose()
  gfx.Dispose()
End Sub

'-----------------------------------------------------------------
'    PictureBox   
'-----------------------------------------------------------------
Private Sub SetPictureBoxDimensions()
  PictureBox1.Width = bitmap_dx
  PictureBox1.Height = bitmap_dy
  PictureBox1.Left = 20
End Sub

'---------------------------------------------------------------------
' :      PictureBox
'---------------------------------------------------------------------
Private Sub buttonDrawBackground_Click(ByVal sender As Object, _
 ByVal e As System.EventArgs) Handles buttonDrawBackground.Click

    SetPictureBoxDimensions()
    CreateBackground()
    PictureBox1.Image = m_backgroundBitmap
End Sub

'-----------------------------------------------------------------------
' :      PictureBox
'-----------------------------------------------------------------------
Private Sub buttonDrawForeground_Click(ByVal sender As Object, _
ByVal e As System.EventArgs) Handles buttonDrawForeground.Click

  SetPictureBoxDimensions()
  CreateForeground()
  PictureBox1.Image = m_foregroundBitmap
End Sub

'---------------------------------------------------------------------------
' :      
'                .   ,  
'                        
'                    
'                
'---------------------------------------------------------------------------
Private Sub buttonDrawBackgroundPlusForeground_Click(ByVal _
  sender As Object, ByVal e As System.EventArgs) _
  Handles buttonDrawBackgroundPlusForeground.Click

  SetPictureBoxDimensions()
  CreateForeground()
  CreateBackground()
  '  Graphics   , 
  '     .
  Dim gfx As System.Drawing.Graphics
  gfx = System.Drawing.Graphics.FromImage(m_backgroundBitmap)

  '--------------------------------------------------------
  '  ImageAttributes.    
  '      
  '--------------------------------------------------------
Dim trasparencyInfo As System.Drawing.Imaging.ImageAttributes
    trasparencyInfo = New System.Drawing.Imaging.ImageAttributes
  '--------------------------------------------------------
  '  
  '--------------------------------------------------------
  trasparencyInfo.SetColorKey(System.Drawing.Color.Yellow, _
                              System.Drawing.Color.Yellow)

  '  
  Dim rect As System.Drawing.Rectangle = _
                New System.Drawing.Rectangle(0, 0, _
                    m_backgroundBitmap.Width, _
                    m_backgroundBitmap.Height)

  '-----------------------------------------------------------------------
  '       
  '     ImageAttributes    
  ',     
  '-----------------------------------------------------------------------
  gfx.DrawImage(m_foregroundBitmap, _
                rect, _
                0, 0, _
                m_foregroundBitmap.Width, _
                m_foregroundBitmap.Height, _
                System.Drawing.GraphicsUnit.Pixel, _
                trasparencyInfo)
  '
  gfx.Dispose()

  '     
  PictureBox1.Image = m_backgroundBitmap
End Sub
