//   
const int DUMMY_ROWS_OF_DATA = 100;
const int NUMBER_TEST_ITERATIONS = 500;

const string TABLE_NAME_PASSENGERINFO = "CustomerTravelInfo";
const string TEST_CREDIT_CARD = "IvoCard-987-654-321-000";

string [] m_data_creditCards; 
string [] m_data_names;
System.DateTime [] m_data_travelDates; 

//-------------------------------------------------------------
//   (   DaraSet)
//-------------------------------------------------------------
private void createDataSet()
{
  //=============================================
  //1.     
  //=============================================
  m_data_creditCards = new string[DUMMY_ROWS_OF_DATA + 1];
  m_data_names = new string[DUMMY_ROWS_OF_DATA + 1];
  m_data_travelDates = 
      new System.DateTime[DUMMY_ROWS_OF_DATA + 1];

  //------------------------------------
  //  
  //------------------------------------
  System.Text.StringBuilder buildTestString;
  buildTestString = new System.Text.StringBuilder();
  for(int addItemsCount = 0; addItemsCount < DUMMY_ROWS_OF_DATA;
       addItemsCount++)
  {
    //   
    m_data_travelDates[addItemsCount] = 
      System.DateTime.Today.AddDays(addItemsCount);

    //------------------------------------
    //  
    //------------------------------------
    // 
    buildTestString.Length = 0;
    buildTestString.Append("TestPersonName");
    buildTestString.Append(addItemsCount);
    m_data_names[addItemsCount] = buildTestString.ToString();

    //-------------------------------------------------------
    //      
    //-------------------------------------------------------
    //     
    buildTestString.Length = 0;
    buildTestString.Append("IvoCard-000-000-0000-");
    buildTestString.Append(addItemsCount);
    m_data_creditCards[addItemsCount] = 
                        buildTestString.ToString();
  }

  // ,        ...
  //       
  m_data_travelDates[DUMMY_ROWS_OF_DATA] = 
                            System.DateTime.Today;
  //    
  m_data_names[DUMMY_ROWS_OF_DATA] = "Ms. TestPerson";
  //    
  m_data_creditCards[DUMMY_ROWS_OF_DATA] = TEST_CREDIT_CARD;
} // 

//------------------------------------------------
// ...
//------------------------------------------------
void changeDayOfTravel_test()
{
  //  
  System.Windows.Forms.Cursor.Current = 
    System.Windows.Forms.Cursors.WaitCursor;

  //   ...
  System.DateTime newDate;
  newDate = System.DateTime.Today;
  changeDayOfTravel_CustomArrays(TEST_CREDIT_CARD, newDate);

  //   !!!
  //        
  //.    .
  System.GC.Collect();
  const int testNumber = 0;

  //  
  PerformanceSampling.StartSample(testNumber, 
                "Custom Array implementation");
  
  // !
  for(int testCount = 0; 
    testCount < NUMBER_TEST_ITERATIONS; testCount++)
  {

    //     
    newDate = newDate.AddDays(1);
    int numberRecordsChanged = 0;

    //  ,  
    numberRecordsChanged = 
          changeDayOfTravel_CustomArrays(
          TEST_CREDIT_CARD, newDate);

    //    ...
    if(numberRecordsChanged != 1)
    {
      System.Windows.Forms.MessageBox.Show(  
        "No matching records found. Test aborted!");
      return;
    }
  }
  //   
  PerformanceSampling.StopSample(testNumber);

  // 
  System.Windows.Forms.Cursor.Current = 
    System.Windows.Forms.Cursors.Default;

  //  
  string runInfo = NUMBER_TEST_ITERATIONS.ToString() + "x" + 
    DUMMY_ROWS_OF_DATA.ToString() + ": ";
  System.Windows.Forms.MessageBox.Show(runInfo +
    PerformanceSampling.GetSampleDurationText(testNumber));
}

private int changeDayOfTravel_CustomArrays(
  string creditCardNumber, System.DateTime newTravelDate)
{
  int numberRecordsChanged = 0;

  //   
  for(int index = 0; index <= DUMMY_ROWS_OF_DATA; index++)
  {
    string currentCreditCard;
    currentCreditCard = m_data_creditCards[index]; 

    //    
    if(creditCardNumber == currentCreditCard)
    {
      //  
      System.DateTime currentTravelDate =  
        m_data_travelDates[index];

      //       
      if(currentTravelDate != newTravelDate)
      {
        m_data_travelDates[index] = 
          newTravelDate;
        numberRecordsChanged++;
      }
    }
  }
  //   
  return numberRecordsChanged;  
}

private void buttonRunTest_Click(object sender,
                                  System.EventArgs e)
{
  createDataSet();
  changeDayOfTravel_test();    
}
