//------------------------------------------------------------
//    
//
//        
//------------------------------------------------------------

using System;

internal class DatabaseAccess
{
const string DATABASE_NAME = "LearnGerman.sdf";
const string  CONNECT_STRING = 
      "Data Source = "+DATABASE_NAME+"; Password = ''";

const string TRANSLATIONTABLE_NAME = "TranslationDictionary";
const string TRANSLATIONTABLE_ENGLISH_COLUMN =  "EnglishWord";
const string TRANSLATIONTABLE_GERMAN_COLUMN =  "GermanWord";
const string TRANSLATIONTABLE_GERMANGENDER_COLUMN =  
      "GermanGender";
const string TRANSLATIONTABLE_WORDFUNCTION_COLUMN =  
      "WordFunction";

internal const int DS_WORDS_COLUMNINDEX_ENGLISHWORD = 0;
internal const int DS_WORDS_COLUMNINDEX_GERMANWORD = 1;
internal const int DS_WORDS_COLUMNINDEX_GERMANGENDER = 2;
internal const int DS_WORDS_COLUMNINDEX_WORDFUNCTION = 3;

static public System.Data.IDataReader GetListOfWords()
{
  System.Data.SqlServerCe.SqlCeConnection conn = null;

  conn = new System.Data.SqlServerCe.SqlCeConnection(
             CONNECT_STRING);
  conn.Open();

  System.Data.SqlServerCe.SqlCeCommand cmd = 
             conn.CreateCommand();

  cmd.CommandText = "select " +
    TRANSLATIONTABLE_ENGLISH_COLUMN             + ", " 
    + TRANSLATIONTABLE_GERMAN_COLUMN            + ", " 
    + TRANSLATIONTABLE_GERMANGENDER_COLUMN      + ", " 
    + TRANSLATIONTABLE_WORDFUNCTION_COLUMN      + " " 
    + "from " + TRANSLATIONTABLE_NAME;

  //   
  System.Data.SqlServerCe.SqlCeDataReader myReader = 
    cmd.ExecuteReader(System.Data.CommandBehavior.SingleResult);

  return myReader;
}

//--------------------------------------------------
//     
//--------------------------------------------------
static public void CreateDatabaseIfNonExistant()
{
  if (System.IO.File.Exists(DATABASE_NAME) == false)
  {
    CreateAndFillDatabase();
  }
}

//--------------------------------------------------
//     
//--------------------------------------------------
static public void  CreateAndFillDatabase()
{
  //  ,    
  if (System.IO.File.Exists(DATABASE_NAME))
  { System.IO.File.Delete(DATABASE_NAME);  }

  //   
  System.Data.SqlServerCe.SqlCeEngine sqlCeEngine;
  sqlCeEngine = new System.Data.SqlServerCe.SqlCeEngine(
                CONNECT_STRING);
  sqlCeEngine.CreateDatabase();

  //-------------------------------------------------
  //    
  //   
  //-------------------------------------------------
  System.Data.SqlServerCe.SqlCeConnection conn = null;
  try 
  {
    conn = new System.Data.SqlServerCe.SqlCeConnection(
           CONNECT_STRING);
    conn.Open();

    System.Data.SqlServerCe.SqlCeCommand cmd = 
           conn.CreateCommand();
			
    //  
    //:
    //   1.     (English)
    //   2.     (German) 
    //   3.   (Gender)
    //   4.  
    cmd.CommandText = "CREATE TABLE " + TRANSLATIONTABLE_NAME +
      " (" + 
      TRANSLATIONTABLE_ENGLISH_COLUMN      + " ntext" + ", " + 
      TRANSLATIONTABLE_GERMAN_COLUMN       + " ntext" + ", " +
      TRANSLATIONTABLE_GERMANGENDER_COLUMN + " int"   + ", " +
      TRANSLATIONTABLE_WORDFUNCTION_COLUMN + " int"   +
      ")";
    cmd.ExecuteNonQuery();

    //   
    FillDictionary(cmd);	
  }
  catch (System.Exception eTableCreate)
  {
    System.Windows.Forms.MessageBox.Show(
    "Error occurred adding table :" + eTableCreate.ToString());
  }
  finally 
  {
    //      
    conn.Close();
  }

  //     
  System.Windows.Forms.MessageBox.Show(
      "Created langauge database!");
}

static private void FillDictionary(
       System.Data.SqlServerCe.SqlCeCommand cmd)
{
  //
  InsertEnglishGermanWordPair(cmd, "to pay", "zahlen", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Verb);
  InsertEnglishGermanWordPair(cmd, "to catch", "fangen", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Verb);
  //  ...

  //
  InsertEnglishGermanWordPair(cmd, "What", "was", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Pronoun);
  //  ...

  //
  InsertEnglishGermanWordPair(cmd, "where", "wo", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Adverb);
  InsertEnglishGermanWordPair(cmd, "never", "nie", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Adverb);
  //  ...

  //
  InsertEnglishGermanWordPair(cmd, "at the", "am", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Preposition);

  // 
  InsertEnglishGermanWordPair(cmd, "invited", "eingeladen",
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Verb);

  InsertEnglishGermanWordPair(cmd, "yellow", "gelbe", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Adjective);
  InsertEnglishGermanWordPair(cmd, "one", "eins", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Adjective);
  InsertEnglishGermanWordPair(cmd, "two", "zwei", 
              VocabularyWord.WordGender.notApplicable,  
              VocabularyWord.WordFunction.Adjective);

  //   
  InsertEnglishGermanWordPair(cmd, "Man", "Mann", 
              VocabularyWord.WordGender.Masculine,  
              VocabularyWord.WordFunction.Noun);
  InsertEnglishGermanWordPair(cmd, "Marketplace", "Marktplatz", 
              VocabularyWord.WordGender.Masculine,  
              VocabularyWord.WordFunction.Noun);
  InsertEnglishGermanWordPair(cmd, "Spoon", "L?ffel ", 
              VocabularyWord.WordGender.Masculine,  
              VocabularyWord.WordFunction.Noun);

  //   
  InsertEnglishGermanWordPair(cmd, "Woman", "Frau", 
              VocabularyWord.WordGender.Feminine,  
              VocabularyWord.WordFunction.Noun);
  InsertEnglishGermanWordPair(cmd, "Clock", "Uhr", 
              VocabularyWord.WordGender.Feminine,  
              VocabularyWord.WordFunction.Noun);
  InsertEnglishGermanWordPair(cmd, "Cat", "Katze", 
              VocabularyWord.WordGender.Feminine,  
              VocabularyWord.WordFunction.Noun);

  //   
  InsertEnglishGermanWordPair(cmd, "Car", "Auto", 
              VocabularyWord.WordGender.Neuter,  
              VocabularyWord.WordFunction.Noun);
  InsertEnglishGermanWordPair(cmd, "Book", "Buch", 
              VocabularyWord.WordGender.Neuter,  
              VocabularyWord.WordFunction.Noun);
}

//------------------------------------------------
//    
//------------------------------------------------
static private void InsertEnglishGermanWordPair(
               System.Data.SqlServerCe.SqlCeCommand cmd, 
               string englishWord, string germanWord, 
               VocabularyWord.WordGender germanWordGender, 
               VocabularyWord.WordFunction wordFunction)
{
  cmd.CommandText = "INSERT INTO " + TRANSLATIONTABLE_NAME + 
   "("+ TRANSLATIONTABLE_ENGLISH_COLUMN + ", " + 
   TRANSLATIONTABLE_GERMAN_COLUMN + ", " + 
   TRANSLATIONTABLE_GERMANGENDER_COLUMN + ", " + 
   TRANSLATIONTABLE_WORDFUNCTION_COLUMN +
    ")  VALUES ('" 
    + englishWord + "', '" 
    + germanWord +  "', '" 
    + System.Convert.ToString(((int) germanWordGender))+ "', '"
    + System.Convert.ToString(((int) wordFunction)) 
    + "')";

  cmd.ExecuteNonQuery();  
}
} // 
