//-------------------------------------------------------------
//     Web-
//      
// [in] httpWhereFrom: URL- 
//      (, "http://someserver/somefile.jpg")
// [in] filenameWhereTo: ,    
//      (, "\\localfile.jpg")
//-------------------------------------------------------------
public void downloadFileToLocalStore(string httpWhereFrom, 
  string filenameWhereTo)
{
  System.IO.FileStream myFileStream = null;
  System.IO.Stream myHTTPResponseStream  = null;
  System.Net.WebRequest myWebRequest  = null;
  System.Net.WebResponse myWebResponse  = null;

  // ,    ,  ,  
  if(System.IO.File.Exists(filenameWhereTo) == true)
  {
    System.IO.File.Delete(filenameWhereTo);
  }

  try
  {
    // Web-
    myWebRequest = 
      System.Net.HttpWebRequest.Create(httpWhereFrom);
    // 
    myWebResponse = myWebRequest.GetResponse();
    //   
    myHTTPResponseStream = myWebResponse.GetResponseStream();

    //  ,      
    myFileStream = System.IO.File.OpenWrite(filenameWhereTo);

    //     
    const int buffer_length = 4000;
    byte [] byteBuffer = new byte[buffer_length];
    int bytesIn;

    //        
    do
    {
      // 
      bytesIn = myHTTPResponseStream.Read(byteBuffer, 
        0, buffer_length);

      // 
      if(bytesIn != 0)
      {
        myFileStream.Write(byteBuffer, 0, bytesIn);
      }
    }while(bytesIn != 0);
  }
  
  catch(Exception myException) //  !
  {
    //- .  
    attemptCleanup_ThrowNoExceptions(myFileStream, 
                    myHTTPResponseStream, myWebResponse);

    //,   ,   ,
    //    ,   !
    throw myException;
  }

  //  !

  //  
  try
  {
    //   
    myFileStream.Close();         myFileStream = null;
    myHTTPResponseStream.Close(); myHTTPResponseStream = null;
    myWebResponse.Close();        myWebResponse = null;
  }
  catch(Exception myException) //    !
  {
    //- .  
    attemptCleanup_ThrowNoExceptions(myFileStream, 
                    myHTTPResponseStream, myWebResponse);

    //,   ,   ,
    //    ,   !
    throw myException;
  }

  // !
}

//----------------------------------------------
//     
//   .
//----------------------------------------------
void attemptCleanup_ThrowNoExceptions(
System.IO.FileStream myFileStream,
System.IO.Stream myHTTPResponseStream,
System.Net.WebResponse myWebResponse)
{
  if(myFileStream != null)
  {
    try 
    { myFileStream.Close(); }
    catch 
    {} //   . 
  }

  if(myHTTPResponseStream != null)
  {
    try
    { myHTTPResponseStream.Close(); }
    catch 
    {} //   . 
  }

  if(myWebResponse != null)
  {
    try
    { myWebResponse.Close(); }
    catch 
    {} //   . 
  }
} // 
