'==================================================================
'.      PerformanceSampling, 
'              .   ,  
'              
'==================================================================
' :
'
' n1  n2   
' n3
'
'  :
'   TRUE:   
'   FALSE:   
'==================================================================
Function returnFalseIfLessThanZero_Add2Numbers( _
          ByVal n1 As Integer, ByVal n2 As Integer, _
          ByRef n3 As Integer) As Boolean

  n3 = n1 + n2

  '  0?
  If (n3 < 0) Then
    Return False
  End If

  Return True
End Function

'==================================================================
' :
'
' n1  n2   
' n3
'
' n3  0,      .
'    TRUE
'===========================================================
Function exceptionIfLessThanZero_Add2Numbers( _
          ByVal n1 As Integer, ByVal n2 As Integer, _
          ByRef n3 As Integer) As Boolean

  n3 = n1 + n2

  '  0?
  If (n3 < 0) Then
    Throw New Exception("  0!")
  End If
  Return True
End Function

'===========================================================
'     
'   
'
'      
'===========================================================
Private Sub buttonRunNoExceptionCode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonRunNoExceptionCode.Click
  Const TEST_NUMBER As Integer = 0
  Dim numberItterations As Integer
  numberItterations = _
    CInt(textBoxNumberAttempts.Text)

  '  ,   
  ListBox1.Items.Add("=>" + numberItterations.ToString() + _
                          " ")

  Dim count_SumLessThanZero As Integer
  Dim dataOut As Integer

  '-----------------------------------------------------------
  ' 
  '-----------------------------------------------------------
  PerformanceSampling.StartSample(TEST_NUMBER, " ")
  '-----------------------------------------------------------
  ' ,     
  '-----------------------------------------------------------
  count_SumLessThanZero = 0
  Dim sumGreaterThanZero As Boolean
  Dim i As Integer
  While (i < numberItterations)

    '=======================
    '  !
    '=======================
    sumGreaterThanZero = _
      returnFalseIfLessThanZero_Add2Numbers(-2, -3, dataOut)

    If (sumGreaterThanZero = False) Then
      count_SumLessThanZero = count_SumLessThanZero + 1
    End If

    i = i + 1
  End While

  '-----------------------------------------------------------
  ' 
  '-----------------------------------------------------------
  PerformanceSampling.StopSample(TEST_NUMBER)

  '-----------------------------------------------------------
  '  
  '-----------------------------------------------------------
  If (count_SumLessThanZero = numberItterations) Then
    MsgBox(" ")
    ListBox1.Items.Add( _
    PerformanceSampling.GetSampleDurationText(TEST_NUMBER))
  Else

    MsgBox("    ")
  End If
End Sub

'===========================================================
'     
'   .
'
'   
'===========================================================
Private Sub buttonRunExceptionCode_Click_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonRunExceptionCode_Click.Click
  Const TEST_NUMBER As Integer = 1

  '  
  Dim numberItterations As Integer
  numberItterations = _
    CInt(textBoxNumberAttempts.Text)

  '  ,   
  ListBox1.Items.Add("=>" + numberItterations.ToString() + _
                            " ")

  Dim count_SumLessThanZero As Integer
  Dim dataOut As Integer

  '-----------------------------------------------------------
  ' 
  '-----------------------------------------------------------
  PerformanceSampling.StartSample(TEST_NUMBER, _
                                  " ")

  '-----------------------------------------------------------
  ' ,     
  '-----------------------------------------------------------
  count_SumLessThanZero = 0
  Dim sumGreaterThanZero As Boolean
  Dim i As Integer
  While (i < numberItterations)
    Try
    '=======================
    '  !
    '=======================
    sumGreaterThanZero = _
      exceptionIfLessThanZero_Add2Numbers(-2, -3, dataOut)

    Catch
      count_SumLessThanZero = count_SumLessThanZero + 1
    End Try

    i = i + 1
  End While ' 

  '-----------------------------------------------------------
  ' 
  '-----------------------------------------------------------
  PerformanceSampling.StopSample(TEST_NUMBER)

  '-----------------------------------------------------------
  '  
  '-----------------------------------------------------------
  If (count_SumLessThanZero = numberItterations) Then

    MsgBox(" ")
    ListBox1.Items.Add( _
      PerformanceSampling.GetSampleDurationText(TEST_NUMBER))
  Else
    MsgBox("    ")
  End If
End Sub
