using System;
public class ThreadExecuteTask
{
  //  
  public enum ProcessingState
  {
    //-------------------
    // 
    //-------------------
    //    
    notYetStarted,

    //-----------------
    // 
    //-----------------
    //   
    waitingToStartAsync, 
    
    //    
    running,  

    //   
    requestAbort,        

    //--------------------
    // 
    //--------------------

    // :   
    // 
    done,                

    // :   
    //  
    aborted              
  }

  ProcessingState m_processingState;

  public delegate void 
     ExecuteMeOnAnotherThread(ThreadExecuteTask checkForAborts);

  private ExecuteMeOnAnotherThread m_CallFunction;
  private object m_useForStateMachineLock;


  public  ThreadExecuteTask
            (ExecuteMeOnAnotherThread functionToCall)
  {
    // ,    
    //     
    m_useForStateMachineLock = new Object();

    //    
    m_processingState = ProcessingState.notYetStarted; 

    // ,   
    //  
    m_CallFunction = functionToCall;

    //----------------------------------------------------------
    //         :
    // this.ThreadStartPoint()
    //----------------------------------------------------------
    System.Threading.ThreadStart threadStart;
    threadStart = 
      new System.Threading.ThreadStart(ThreadStartPoint);
    
    System.Threading.Thread newThread;
    newThread = new System.Threading.Thread(threadStart);

    //     (  
    //     ,    !)
    setProcessingState(ProcessingState.waitingToStartAsync);

    //         
    newThread.Start();
    //  ,   
  }

  //---------------------------------------------
  //    , 
  //    
  //---------------------------------------------
  private void ThreadStartPoint()
  {
    //  , 
    //    !
    setProcessingState(ProcessingState.running);

    //          
    //,      ,     
    //  
    m_CallFunction(this);

    //    ,    ,
    //    
    if(m_processingState != ProcessingState.aborted)
    {
      //  
      setProcessingState(ProcessingState.done);
    }

    //  ...
  }

  //--------------------------------------------------
  //  
  //--------------------------------------------------
  public void setProcessingState(ProcessingState nextState)
  {
    //        
    //     
    lock(m_useForStateMachineLock)
    {
      //        
      //    
      if (m_processingState == nextState)
      {
        return;
      }

      //------------------------------------------------------
      //  , 
      //    ,  
        //  ,   
        //-------------------------------------------------------

      if   ((m_processingState == ProcessingState.aborted)
        ||  (m_processingState == ProcessingState.done))
      {
        return;
      }

      //     
      switch(nextState)
      {
        case ProcessingState.notYetStarted:
          throw new Exception
            ("   'notYetStarted' ");

        case ProcessingState.waitingToStartAsync:
          if(m_processingState != ProcessingState.notYetStarted)
          {throw new Exception("  ");}
          break;

        case ProcessingState.running:
          if(m_processingState != 
             ProcessingState.waitingToStartAsync)
          {throw new Exception("  ");}

          break;

        case ProcessingState.done:
          //     ,   . 
          //     ,   
          // ,        
          if((m_processingState != ProcessingState.running) && 
             (m_processingState != ProcessingState.requestAbort)
            )
          {throw new Exception("  ");}

          break;

        case ProcessingState.aborted:
          if(m_processingState != ProcessingState.requestAbort)
          {throw new Exception("  ");}

          break;
      }

      //  
      m_processingState = nextState;
    }
  }

  public ProcessingState State
  {
    get 
    {
      ProcessingState currentState;
      //   / 
      lock(m_useForStateMachineLock)
      {
        currentState = m_processingState;
      }
      return currentState;
    }
  }
} // 
